Unit QSG2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSG2R(var INT :Real; A :Real; B :Real; F :Func_F1);

implementation

procedure QSG2R(var INT :Real; A :Real; B :Real; F :Func_F1);
var
K :Integer;
D,E,G,H :Real;
C :Array [0..2] of Real;
C1 :Array [0..2] of Real;
label
_1;
begin
{   DATA  FORTRAN  }
C[0] := 0.4662347;
C[1] := 0.3306046;
C[2] := 0.1193095;
C1[0] := 0.08566225;
C1[1] := 0.1803807;
C1[2] := 0.2339569;
H := 0.0;
D := 0.5*(A+B);
E := B-A;
for K:=1 to 3 do
 begin
  G := E*C[K-1];
  H := H+C1[K-1]*(F(D+G)+F(D-G));
_1:
 end;
INT := H*E;
end;

end.
